<?php

class displayhandler_additionalfields
{
    /**
     * Overview
     */
    public function overview()
    {
        ?>
        <div class="wrap">
            <h2>v4 WP1CRM - Extensions</h2>

            <table class="form-table">
                <tbody>
                <tr>
                    <th scope="row"><a href="<?php menu_page_url('wp1crm-additional-fields'); ?>">v4 Woo Custom Fields</a></th>
                    <td>
                        custom fields for WooCommerce checkout
                    </td>
                </tr>
                </tbody>
            </table>
            <?php
            //oauth
            if (is_plugin_active('v4-oauth/v4oAuth.php')) {
                ?>
                <table class="form-table">
                    <tbody>
                    <tr>
                        <th scope="row"><a href="<?php menu_page_url('v4-OAuth'); ?>">v4 oAuth</a></th>
                        <td>
                            <h3>URL Parameter for login</h3>
                            <ul>
                                <li>
                                    <strong>connect=1crm</strong> login via 1crm (redirects user by default back to the
                                    last visited / his current page)
                                </li>
                                <li>
                                    <strong>redirect_to=URL</strong> redirects user to specific URL after Login
                                </li>
                            </ul>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <?php
            }
            //SelfService
            if (is_plugin_active('v4-selfservice/v4-selfservice.php')) {
                ?>
                <table class="form-table">
                    <tbody>
                    <tr>
                        <th scope="row"><a href="<?php menu_page_url('v4-selfservice'); ?>">v4 SelfService</a></th>
                        <td>

                        </td>
                    </tr>
                    </tbody>
                </table>
                <?php
            }
            //wp webhook
            if (is_plugin_active('v4-wp-webhook/v4-wp-webhook.php')) {
                ?>
                <table class="form-table">
                    <tbody>
                    <tr>
                        <th scope="row"><a href="<?php menu_page_url('v4-wpwh-admin'); ?>">v4 WP Webhook</a></th>
                        <td>
                            <h3>Shortcodes</h3>
                            <p>shortcode attributes are optional</p>
                            <ul>
                                <li><code>[wpwh_my_account button-class="button" redirect_to="URL" register="1" register_instant_login="0"]</code></li>
                                <li><code>[wpwh_login button-class="button" redirect_to="URL" register="1" register_instant_login="0"]</code></li>
                                <li><code>[wpwh_register button-class="button" redirect_to="URL" instant_login="0"]</code></li>
                            </ul>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <?php
            }
            ?>

            <table class="form-table">
                <tbody>
                <tr>
                    <th scope="row"><a href="<?php menu_page_url('wp1crm-Tools'); ?>">v4 Tools</a></th>
                    <td>
                        <p>admin tools</p>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
        <?php
    }

    /**
     * Additional Fields
     */
    public function additional_fields()
    {

        ?>
        <div class="wrap">
            <h2>v4 Woo Custom Fields</h2>

            <form method="post" action="options.php" id="addfieldsform">
                <?php wp_nonce_field('additional_fields'); ?>
                <?php settings_fields('wp1crmadditionalfields-group'); ?>
                <?php do_settings_sections('wp1crmadditionalfields-group');

                $this->general_settings();

                $this->section_divs('billing');
                $this->section_divs('shipping');
                //$this->section_divs('account');
                $this->section_divs('order');
                ?>

                <?php submit_button(); ?>

            </form>
        </div>

        <?php
    }

    private function general_settings()
    {
        $wp1crm = get_option('wp1crm');
        ?>
        <div class="customfieldsdivs">
            <h2>Einstellungen</h2>
            <div>
                <label for="wp1crm-settings-b2b">
                    USt.ID.
                    <span class="infoWindow">
                        Die USt.ID. wird als Feld im Bestellprozess hinzugefügt. Es ist ein Pflichtfeld wenn "Land" nicht "Deutschland" entspricht.
                    </span>
                </label>
                <input
                    type="checkbox"
                    id="wp1crm-settings-b2b"
                    name="wp1crm[b2b]"
                    value="1"
                    <?php if (!empty($wp1crm['b2b'])) {
                        echo 'checked="checked"';
                    } ?>
                >
            </div>
            <div>
                <label for="wp1crm-settings-name_readonly">
                    Name nicht editierbar
                    <span class="infoWindow">
                        Setzt das Feld im Checkout Prozess auf readonly. Feld kann durch den Code oder durch XSS immer noch geändert werden.
                    </span>
                </label>
                <input
                    type="checkbox"
                    id="wp1crm-settings-name_readonly"
                    name="wp1crm[name_readonly]"
                    value="1"
                    <?php if (!empty($wp1crm['name_readonly'])) {
                        echo 'checked="checked"';
                    } ?>
                >
            </div>
            <div>
                <label for="wp1crm-settings-company_readonly">
                    Firmenfeld nicht editierbar
                    <span class="infoWindow">
                        Setzt das Feld im Checkout Prozess auf readonly. Feld kann durch den Code oder durch XSS immer noch geändert werden.
                    </span>
                </label>
                <input
                    type="checkbox"
                    id="wp1crm-settings-company_readonly"
                    name="wp1crm[company_readonly]"
                    value="1"
                    <?php if (!empty($wp1crm['company_readonly'])) {
                        echo 'checked="checked"';
                    } ?>
                >
            </div>
            <div>
                <label for="wp1crm-settings-email_readonly">
                    E-Mail nicht editierbar
                    <span class="infoWindow">
                        Setzt das Feld im Checkout Prozess auf readonly. Feld kann durch den Code oder durch XSS immer noch geändert werden.
                    </span>
                </label>
                <input
                    type="checkbox"
                    id="wp1crm-settings-email_readonly"
                    name="wp1crm[email_readonly]"
                    value="1"
                    <?php if (!empty($wp1crm['email_readonly'])) {
                        echo 'checked="checked"';
                    } ?>
                >
            </div>
            <div>
                <label for="wp1crm-settings-order_for_customer">
                    Bestellungen für andere Kunden
                    <span class="infoWindow">
                        erlaubt die Bestellung für andere Kunden, wenn die Benutzerrolle übereinstimmt.
                        Im CRM wird ein neuer Kontakt und eine neue Firma angelegt, ohne login infos.
                        Die Daten werden dann im erstellten Datensatz (Angebot/Auftrag/Rechnung) verknüpft.
                    </span>
                </label>
                <input
                    type="checkbox"
                    id="wp1crm-settings-order_for_customer"
                    name="wp1crm[order_for_customer]"
                    value="1"
                    <?php if (!empty($wp1crm['order_for_customer'])) {
                        echo 'checked="checked"';
                    } ?>>
                <select
                    id="wp1crm-settings-order_for_customer"
                    name="wp1crm[order_for_customer_roles][]"
                    multiple
                >
                    <?php
                    global $wp_roles;
                    foreach ($wp_roles->roles as $role_key => $role) {
                        $selected = '';
                        if (is_array($wp1crm['order_for_customer_roles']) &&
                            in_array($role_key, $wp1crm['order_for_customer_roles'])
                        ) {
                            $selected = 'selected';
                        }
                        ?>
                        <option value="<?= $role_key ?>" <?= $selected ?>><?= $role['name'] ?></option>
                        <?php
                    }
                    ?>
                </select>
            </div>
        </div>
        <div class="customfieldsdivs"><!--empty div--></div>
        <?php
    }

    private function section_divs($prefix)
    {
        ?>
        <div id="<?php echo v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']; ?>div"
             class="customfieldsdivs">
            <h2><?= v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['headlineD'] ?></h2>
            <input type="button" class="button action donotserialize newfield"
                   name="<?php echo v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']; ?>addButton"
                   id="<?php echo v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']; ?>addButton"
                   value="+ Feld hinzufügen">
            <?php
            $this->GenerateFieldsFromArrayString(
                get_option(v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid'])
            );
            ?>
            <input
                id="<?php echo v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']; ?>" type="hidden"
                name="<?php echo v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']; ?>"
                value="<?php
                echo esc_attr(get_option(v4_wp1crm_Extensions_Public_Setting::$SECTIONS[$prefix]['htmlid']));
                ?>"
                class="donotserialize"/>
        </div>

        <?php
    }

    private function GenerateFieldsFromArrayString($arraystring)
    {

        $decodedCustomfieldsArray = json_decode($arraystring, true);

        if ($decodedCustomfieldsArray !== null or json_last_error() == JSON_ERROR_NONE) {
            $hidevalues = false;
            $valuestext = '';

            foreach ((array)$decodedCustomfieldsArray as $field) {
                ?>

                <?php
                if ($field['name'] == 'fieldname') {
                    ?>
                    <div>
                    <label for='fieldname'>Feld Name:<span
                                class='infoWindow'>Der im Bestellprozess angezeigte Feldname.</span></label>
                    <input id='fieldname' type='text' name='fieldname' value='<?= $field['value'] ?>' required><br/>
                    <?php
                } elseif ($field['name'] == 'fieldid') {
                    ?>
                    <label for='fieldid'>Feld-ID im 1CRM:<span class='infoWindow'>Zur fehlerfreien Synchronisation muss diese ID identisch mit der im 1CRM angegebenen Feld-ID sein. Keine Leerzeichen, Sonderzeichen und Umlaute verwenden!</span></label>
                    <input id='fieldid' type='text' name='fieldid' value='<?= $field['value'] ?>' required><br/>
                    <?php
                } elseif ($field['name'] == 'fieldtype') {
                    ?>
                    <label for='fieldtype'>
                        Feld Typ:<span class='infoWindow'>Der Typ des im Bestellprozess angezeigten Feldes.</span>
                    </label>
                    <select id='fieldtype' class='fieldtype' name='fieldtype'><?php

                    if ($field['value'] == 'input') {
                        ?>
                            <option value='input' selected>input</option>
                            <option value='dropdown'>DropDown</option>
                            <option value='checkbox'>Checkbox</option>
                            <option value='textarea'>Textarea</option>
                        <?php
                        $hidevalues = true;
                    } elseif ($field['value'] == 'dropdown') {
                        ?>
                            <option value='input'>input</option>
                            <option value='dropdown' selected>DropDown</option>
                            <option value='checkbox'>Checkbox</option>
                            <option value='textarea'>Textarea</option>
                        <?php
                        $valuestext = "DropDown Inhalte (separiert durch Semikolon):";
                    } elseif ($field['value'] == 'checkbox') {
                        ?>
                            <option value='input'>input</option>
                            <option value='dropdown'>DropDown</option>
                            <option value='checkbox' selected>Checkbox</option>
                            <option value='textarea'>Textarea</option>
                        <?php
                        $hidevalues = true;
                    } elseif ($field['value'] == 'textarea') {
                        ?>
                            <option value='input'>input</option>
                            <option value='dropdown'>DropDown</option>
                            <option value='checkbox'>Checkbox</option>
                            <option value='textarea' selected>Textarea</option>
                        <?php
                        $hidevalues = true;
                    }
                    ?>
                    </select>
                    <?php
                } elseif ($field['name'] == 'fieldvalues') {
                    if ($hidevalues) {
                        ?><label for='fieldvalues' style='display: none;'>Feld Values:</label>
                        <input type='text'
                               id='fieldvalues'
                               name='fieldvalues'
                               value='<?= $field['value'] ?>'
                               style='display: none;'>
                        <?php
                        $hidevalues = false;
                    } else {
                        ?>
                        <label for='fieldvalues'>
                            <?= $valuestext ?>
                            <span class='infoWindow'>Bitte keine Sonderzeichen und Umlaute verwenden!</span>
                        </label>
                        <input id='fieldvalues' type='text' name='fieldvalues' value='<?= $field['value'] ?>' required>
                        <?php
                        $valuestext = '';
                    }
                    ?>
                    <input type='button' class='deleteButtons donotserialize button action'
                           value='- löschen'>
                    </div>
                    <?php
                }
                ?>
                <?php
            }
        }
    }

    public function tools()
    {
        ?>

        <div class="wrap">
            <h2>v4 Tools</h2>
            <?php
            do_action('v4/wp/plugins/wp1crm/display_tools');
            ?>
        </div>
        <?php
    }
}